package com.citygis.service;

import com.alibaba.fastjson.JSONObject;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @Package com.citygis.service
 * @Author zyl
 * @Date 2024/1/25 0025 13:38
 * @description: 登录弃用
 */
//@ConfigurationProperties(prefix = "the-url")
@Service
public class LoginServiceImpl1 {

    private String ssoRet;

    private String tokenYZ;

    private String accesstoken;

    public String getAccesstoken() {
        return accesstoken;
    }

    public void setAccesstoken(String accesstoken) {
        this.accesstoken = accesstoken;
    }

    public String getTokenYZ() {
        return tokenYZ;
    }

    public void setTokenYZ(String tokenYZ) {
        this.tokenYZ = tokenYZ;
    }

    public String getSsoRet() {
        return ssoRet;
    }

    public void setSsoRet(String ssoRet) {
        this.ssoRet = ssoRet;
    }


    private final String[] appCodes = {"bm", "sz", "bl", "gis"};

    private final String[] loginUrls = {"https://172.27.128.14/bm/LoginWebService/LoginGisESB.aspx", "https://172.27.128.81/sz/LoginWebService/LoginGisESB.aspx", "http://172.27.128.50/WCDC/LoginWebService/LoginGisESB.aspx"};

    private final String[] gisURLs = {"https://172.27.128.14/bm/bm/Default.html", "https://172.27.128.81/sz/jksz/Default.html", "https://172.27.128.50/wcdc/CaseDistribution.html", "https://172.27.128.107/gis/gx/Default.html"};

    private final String[] client_ids = {"2024918183454092831", "", "2024943772869244556", ""};

    private RestTemplate restTemplate;

    public void UrlForwardingController(RestTemplate restTemplate) {
        this.restTemplate = restTemplate;
    }

    public void page_Load(HttpServletRequest request, HttpServletResponse response, Integer serviceType) throws IOException {

        String tokenValue = null;

        Cookie[] cookies = request.getCookies();
        if (cookies != null) {
            for (Cookie cookie : cookies) {
                if (accesstoken.equals(cookie.getName())) {
                    // 找到了名为“accesstoken”的Cookie
                    tokenValue = cookie.getValue();
                    // TODO: 处理Cookie的值
                }
            }
        }
        String tokenID = null;

        String returnURL = ssoRet;

        String appCode = appCodes[serviceType];
//        returnURL = returnURL + "?AppCode=" + appCode + "&returnUrl=" + URLEncoder.encode(loginUrls[serviceType], StandardCharsets.UTF_8.toString());
        String gisURL = gisURLs[serviceType];

        String accesstoken1 = request.getHeader(accesstoken);

        if (accesstoken1 != null && !accesstoken1.isEmpty()) {
            tokenID = request.getHeader(accesstoken);
            Cookie tokenCookie = new Cookie(accesstoken, tokenID);
            tokenCookie.setHttpOnly(true);
            response.addCookie(tokenCookie);
        } else if (tokenValue != null) {
            tokenID = tokenValue;
        }


        if (tokenID != null) {
//            if (!isNumAndEn(tokenID)) {
//                response.sendRedirect(ssoRet);
//                return;
//            }
            boolean b = checkAccessToken(tokenID);
            if (b) {
                System.out.println("成功--->" + appCode + "--->" + returnURL);
                response.sendRedirect(returnURL);
                return;
            } else {
                System.out.println("失败1");
                response.sendRedirect(returnURL);
                return;
            }

        } else {
            System.out.println("失败2");
            response.sendRedirect(returnURL);
            return;
        }

    }

    public static boolean isNumAndEn(String input) {
        String pattern = "^[A-Za-z0-9]+$";
        Pattern regex = Pattern.compile(pattern);
        Matcher matcher = regex.matcher(input);
        return matcher.matches();
    }

    public boolean checkAccessToken(String tokenID) {
        System.out.println(tokenYZ);
        String targetUrl = tokenYZ;
        HttpHeaders headers = new HttpHeaders();
        headers.add(accesstoken, tokenID);
        HttpEntity<?> requestEntity = new HttpEntity<>(null, headers);
        ResponseEntity<String> response = restTemplate.exchange(targetUrl, HttpMethod.GET, requestEntity, String.class);
        System.out.println(response);
        String responseStr = response.toString();

        JSONObject jsonObject = JSONObject.parseObject(responseStr);
        String errorMsgStr = jsonObject.get("errorMsg").toString();

        if (errorMsgStr.equals("OK")) {
            return true;
        } else {
            return false;
        }

    }
}
